/**
 * Transmission App
 * Implementing Transmission App
 */
var LeanoteApp = LeanoteApp || {};  //Define Transmission App namespace.
/**
 * Constructor UNAS App
 */
LeanoteApp.App = function () {
    this.id             = 'Leanote';
    this.name           = 'Leanote';
    this.version = '6.0.7';
    this.active         = false;
    this.menuIcon       = '/apps/leanote/images/logo.png?v=6.0.7&';
    this.shortcutIcon   = '/apps/leanote/images/logo.png?v=6.0.7&';
    var self            = this;
    this.LeanoteAppWindow = function () {
        if(UNAS.CheckAppState('Leanote')){
            return false;
        }
        self.window = new MUI.Window({
            id:             'LeanoteAppWindow',
            title:          UNAS._('Leanote'),
            icon:           '/apps/leanote/images/logo_small.png?v=6.0.7&',
            loadMethod:     'xhr',
            width:          750,
            height:         480,
            maximizable:    false,
            resizable:      true,
            scrollbars:     false,
            resizeLimit:    { 'x': [650, 1200], 'y': [450, 900] },
            contentURL:     '/apps/leanote/leanote.html?v=6.0.7&',
            onBeforeBuild:  function(){UNAS.SetAppOpenedWindow("Leanote",'LeanoteAppWindow')}
        });
    };
    this.LeanoteUninstall = function () {
        UNAS.RemoveDesktopShortcut('Leanote');
        UNAS.RemoveMenu('Leanote');
        UNAS.RemoveAppFromGroups('Leanote', 'ControlPanel');
        UNAS.RemoveAppFromApps('Leanote');
    };
    new UNAS.Menu('UNAS_App_Internet_Menu', this.name, this.menuIcon, 'Leanote', '', this.LeanoteAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Leanote', this.LeanoteAppWindow);
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Leanote', UNAS._('Leanote')); //translate menu
        UNAS.SetShortcutTitle('Leanote', UNAS._('Leanote'));
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('LeanoteAppWindow', UNAS._('Leanote'));
        }
    };
    UNAS.LoadTranslation('/apps/leanote/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name, this.shortcutIcon, this.LeanoteAppWindow, this.LeanoteUninstall);
};

new LeanoteApp.App();
